/* Copyright (C) 2011, 2012, 2013 by Bundesanstalt für Gewässerkunde
 * Software engineering by Intevation GmbH
 *
 * This file is Free Software under the GNU AGPL (>=v3) 
 * and comes with ABSOLUTELY NO WARRANTY! Check out the
 * documentation coming with Dive4Elements River for details. 
 */

package org.dive4elements.river.artifacts.access;

import java.util.Arrays;

import org.apache.log4j.Logger;

import org.dive4elements.artifacts.CallContext;
import org.dive4elements.river.artifacts.D4EArtifact;
import org.dive4elements.river.utils.RiverUtils;
import org.dive4elements.river.utils.StringUtil;


public class BedDifferencesAccess
extends RiverAccess
{
    private static Logger logger = Logger.getLogger(BedDifferencesAccess.class);
    private String yearEpoch;
    private String[] diffs;

    private CallContext context;

    public BedDifferencesAccess(D4EArtifact artifact, CallContext context) {
        super(artifact);
        this.context = context;
    }

    public String getYearEpoch() {
        yearEpoch = getString("ye_select");
        return yearEpoch;
    }

    public D4EArtifact[][] getDifferenceArtifacts() {
        diffs = getString("diffids").split("#");
        logger.debug("diffs: " + Arrays.toString(diffs));
        D4EArtifact[][] artifacts = new D4EArtifact[diffs.length/2][2];
        for (int i = 0; i < diffs.length; i += 2) {
            String diff1 = StringUtil.unbracket(diffs[0 + 2*i]);
            String diff2 = StringUtil.unbracket(diffs[1 + 2*i]);
            String[] diff1parts = diff1.split(";");
            String[] diff2parts = diff2.split(";");
            logger.debug("creating 2 artifacts." + diff1parts[0] + "; " + diff2parts[0]);
            artifacts[i][0] = RiverUtils.getArtifact(diff1parts[0], context);
            artifacts[i][1] = RiverUtils.getArtifact(diff2parts[0], context);
        }
        return artifacts;
    }

    public static int getHeightId(D4EArtifact artifact) {
        Access a = new Access(artifact);
        return a.getInteger("height_id");
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
